/******************************************************************************
 * @brief        ATͨŹ(OS汾)
 *
 * Copyright (c) 2020, <morro_luo@163.com>
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Change Logs: 
 * Date           Author       Notes 
 * 2020-01-02     Morro        Initial version. 
 * 2021-02-01     Morro        ֧URCصн.
 * 2021-02-05     Morro        1.޸struct at_obj,ȥ
 *                             2.ɾ at_obj_destroyӿ
 * 2021-03-21     Morro        ɾat_objеat_work_ctx_t,ڴʹ
 * 2021-04-08     Morro        ظͷźֵȴʱ
 * 2021-05-15     Morro        ŻURCƥ
 * 2021-07-20     Morro        ӽ,ִat_do_workʱurcݶʧ
 ******************************************************************************/

#ifndef _AT_H_
#define _AT_H_

#include "at_util.h"
#include <stdbool.h>

/*  */ 
#define MAX_AT_CMD_LEN        128

/* urcճʱʱ*/  
#define MAX_URC_RECV_TIMEOUT  300      

/* ָURC б */
#define SPEC_URC_END_MARKS     ":,\r\n"
     
struct at_obj;                                                /* AT*/

/*ATӦ ---------------------------------------------------------------*/
typedef enum {
    AT_RET_OK = 0,                                            /* ִгɹ*/
    AT_RET_ERROR,                                             /* ִд*/
    AT_RET_TIMEOUT,                                           /* Ӧʱ*/
	AT_RET_ABORT,                                             /* δ֪*/
}at_return;

/**
 * @brief URC (Context) 
 */
typedef struct {
    /**
     * @brief   ݶȡӿ
     * @params  buf   - 
     * @params  len   - С    
     */
    unsigned int (*read)(void *buf, unsigned int len);       
    char *buf;                                                /* ݻ */
    int bufsize;                                              /* С */
    int recvlen;                                              /* ѽݳ*/
} at_urc_ctx_t;

/*(Unsolicited Result Codes (URCs)) ------------------------------------*/
typedef struct {
    /**
     * @brief urc ǰ׺("+CSQ: ")
     */    
    const char *prefix;
    /**
     * @brief urc ַָ(οDEF_URC_END_MARKSбָĬ"\n")
     * @note  
     */     
    const char *end_mark;
    /**
     * @brief       urc
     * @params      ctx - URC 
     */
    void (*handler)(at_urc_ctx_t *ctx);
}urc_item_t;
    
/**
 * @brief ATӿ(ڳʼAT)
 */
typedef struct {
    
    /**
     * @brief дӿ
     */    
    unsigned int (*write)(const void *buf, unsigned int len);
    
    /**
     * @brief ݶӿ
     */    
    unsigned int (*read)(void *buf, unsigned int len);         
    /**
     * @brief Դӡӿ,ҪNULL
     */      
    void         (*debug)(const char *fmt, ...);  
    
    /**
     * @brief urc ,ҪNULL
     */     
	urc_item_t    *utc_tbl;
    /**
     * @brief urcջ,ҪNULL
     */
	char          *urc_buf;
    /**
     * @brief utc_tbl,Ҫ0
     */    
	unsigned short urc_tbl_count;  
    /**
     * @brief urcС,Ҫ0
     */      
	unsigned short urc_bufsize;
}at_adapter_t;

/**
 * @brief ATӦ
 */
typedef struct {    
    const char    *matcher;                                   /* ƥ䴮 */
    char          *recvbuf;                                   /* ջ */
    unsigned short bufsize;                                   /*  */
    unsigned int   timeout;                                   /* ʱʱ */
} at_respond_t;

/** work context  ------------------------------------------------------------*/
/**
 * @brief ATҵ(Work Context) 
 */
typedef struct at_work_ctx {
    struct at_obj *at;
    
    //ҵ,at_do_workӿڴ
	void          *params;
    /**
     * @brief   д
     */    
    unsigned int (*write)(struct at_work_ctx *self, const void *buf, unsigned int len);
    /**
     * @brief   ݶ
     */     
    unsigned int (*read)(struct at_work_ctx *self, void *buf, unsigned int len);
    
    /**
     * @brief   ʽӡ    
     */     
	void         (*printf)(struct at_work_ctx *self, const char *fmt, ...);
    /*
     * @brief       ȴظ
     * @param[in]   prefix  - ڴǰ׺("OK",">")
     * @param[in]   timeout - ȴʱʱ
     */
	at_return    (*wait_resp)(struct at_work_ctx *self, const char *prefix, 
                              unsigned int timeout);
}at_work_ctx_t;


/*AT ---------------------------------------------------------------------*/
typedef struct at_obj {
	at_adapter_t            adap;                             /* ӿ*/
	at_sem_t                send_lock;                        /* */
    at_sem_t                recv_lock;                        /* */
	at_sem_t                completed;                        /* ź*/
    at_respond_t            *resp;                            /* ATӦϢ*/
    const urc_item_t        *urc_item;                        /* ǰURC*/
	unsigned int            resp_timer;                       /* Ӧնʱ*/
	unsigned int            urc_timer;                        /* URCʱ */
	at_return               ret;                              /* ִн*/
	unsigned short          urc_cnt, rcv_cnt;                 /* ռ*/
	unsigned char           busy   : 1;
	unsigned char           suspend: 1;
    unsigned char           dowork : 1;
}at_obj_t;

typedef int (*at_work)(at_work_ctx_t *);

void at_obj_init(at_obj_t *at, const at_adapter_t *adap);      /* ATʼ*/

bool at_obj_busy(at_obj_t *at);

void at_suspend(at_obj_t *at);                                 /* */
 
void at_resume(at_obj_t *at);                                  /* ָ*/

at_return at_do_cmd(at_obj_t *at, at_respond_t *r, const char *cmd);

int at_split_respond_lines(char *recvbuf, char *lines[], int count, char separator);

int at_do_work(at_obj_t *at, at_work work, void *params);      /* ԶATҵ*/


void at_process(at_obj_t *at);                                 /* ATմ*/
        
#endif
